.TH PREDEP 1 "Feb 15 1994" "Stanford University" "SUIF Compiler"
.SH NAME
predep \- preprocessing for the dependence analyzer
.SH SYNOPSIS
.B predep
.I -normalize
|
.I -presc
[
.I -verbose
]
.I infile outfile .\^.\^.
.SH DESCRIPTION
This pass performs two preprocessing steps that are useful to the
parallelizer. 
.sp
.SH OPTIONS
.TP
.B \-presc
This preprocessing pass is needed by the 
.I dependence analyzer 
to handle array accesses with symbolic coefficients.  Since the sign
of the symbolic coefficient affects the dependence, the code is
modified such that multiple loop nests are created for symbolic
coefficients. Three loop nests are created for a symbolic coefficient
such that the symbolic coefficient is greater than zero, less than
zero, or equal to zero in each of the nests.
.sp
.TP
.B \-normalize
Normalize all the
.I  TREE_FORs
by modifying all array references and loop definitions so that the
step is always one and the loop test is always less-than-or-equal.
.sp
.TP
.B \-expand <number>
Maximum number of symbolic coefficients each loop nest is expanded.
The default is 2 symbolic coefficient.  After expanding for 
<number> symbolic coefficient 2^<number> loop nests are created.
.sp
.TP
.B \-verbose
Print a detailed description on what is going on.

.SH HISTORY
The pass 
.I predep 
was written by Saman Amarasinghe.  The normalization code in the 
.I dependence library 
was originally written by Dror Maydan and Michael Wolf and was ported
to new SUIF by Jennifer Anderson.  The dependence analysis of array
accesses with symbolic coefficients in the
.I dependence library
was written by Saman Amarasinghe.

